diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
index 314f3fbd8..9e043c216 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -7,15 +11,18 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.MapItem;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
 
+import java.util.List;
+import java.util.Objects;
+
 public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
     {
         ItemStack map = null;
         int paperAmount = 0;
-        for (int i = 0; i < inventorycrafting.getContainerSize(); i++) {
-            ItemStack s = inventorycrafting.getItem(i);
+        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
+            ItemStack s = craftingContainer.getItem(i);
             if (s != null)
             {
                 Item item = s.getItem();
@@ -38,21 +45,21 @@ public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting) {
-        for (int i = 0; i < inventorycrafting.getContainerSize(); i++) {
-            inventorycrafting.setItem(i, null);
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer) {
+        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
+            craftingContainer.setItem(i, null);
         }
         return new ItemStack[0];
     }
 
     @Override
-    public boolean matches(CraftingContainer inventorycrafting) {
+    public boolean matches(CraftingContainer craftingContainer) {
         ItemStack mapStack = null;
         boolean hasPaper = false;
 
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
@@ -78,6 +85,82 @@ public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
 
     @Override
     public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        ItemStack output = Items.MAP.getDefaultStack();
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                return true;
+            } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                return true;
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(output);
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {new RecipeSymbol(Items.MAP.getDefaultStack())};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
         return false;
     }
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
index 223cb68d3..ace2cb176 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
@@ -1,14 +1,26 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryRepairableJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
 
-public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
+import java.util.List;
+import java.util.Objects;
+
+public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic implements HasJsonAdapter {
     public ItemStack inItem;
     public RecipeSymbol repairMaterial;
 
+    public RecipeEntryRepairable() {
+
+    }
 
     public RecipeEntryRepairable(ItemStack inItem, RecipeSymbol repairMaterial)
     {
@@ -17,7 +29,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(CraftingContainer inventorycrafting)
+    public boolean matches(CraftingContainer craftingContainer)
     {
         int repairMaterialCount = 0;
         int inItemCount = 0;
@@ -26,7 +38,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (repairMaterial.matches(stack))
                 {
@@ -49,10 +61,86 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
 
     @Override
     public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        ItemStack output = inItem;
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                return true;
+            } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                return true;
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(output);
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {new RecipeSymbol(inItem), repairMaterial};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
         return false;
     }
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
     {
         int repairMaterialCount = 0;
         ItemStack inItemStack = null;
@@ -61,7 +149,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (repairMaterial.matches(stack))
                 {
@@ -91,12 +179,12 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
             for(int y = 0; y < 3; y++) {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 ItemStack stack2;
                 if(stack.stackSize-1 == 0)
@@ -104,7 +192,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
                 else {
                     stack2 = new ItemStack(stack.getItem(), stack.stackSize - 1);
                 }
-                inventorycrafting.setSlotContentsAt(x, y, stack2);
+                craftingContainer.setSlotContentsAt(x, y, stack2);
             }
         }
         return returnStack;
@@ -114,4 +202,9 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
     public int getRecipeSize() {
         return 2;
     }
+
+    @Override
+    public RecipeJsonAdapter<?> getAdapter() {
+        return new RecipeEntryRepairableJsonAdapter();
+    }
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
index e7e02ccae..8e3040c08 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairableStackable.java
@@ -15,7 +15,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(CraftingContainer inventorycrafting)
+    public boolean matches(CraftingContainer craftingContainer)
     {
         int materialStackCount = 0;
         int inItemCount = 0;
@@ -24,7 +24,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == materialStack.itemID)
                 {
@@ -51,7 +51,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
     {
         ItemStack inItemStack = null;
         totalStackCount = 0;
@@ -59,7 +59,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == materialStack.itemID)
                 {
@@ -87,15 +87,15 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
         int repairCost =  originalDamage - inItemStack.getMetadata();
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
             for(int y = 0; y < 3; y++) {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
-                if (stack.getItem() == inItem) inventorycrafting.setSlotContentsAt(x, y, null);
+                if (stack.getItem() == inItem) craftingContainer.setSlotContentsAt(x, y, null);
                 if (stack.getItem() == materialStack.getItem()) {
                     ItemStack replacementStack;
                     if (repairCost <= 0) return returnStack;
@@ -105,7 +105,7 @@ public class RecipeEntryRepairableStackable extends RecipeEntryCraftingDynamic {
                         replacementStack = new ItemStack(stack.getItem(), stack.stackSize - repairCost);
                     }
                     repairCost = repairCost - stack.stackSize;
-                    inventorycrafting.setSlotContentsAt(x, y, replacementStack);
+                    craftingContainer.setSlotContentsAt(x, y, replacementStack);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
index c63678393..45c18bc6c 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryScrap.java
@@ -1,32 +1,47 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryScrapJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
 
-public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
+import java.util.List;
+import java.util.Objects;
+
+public class RecipeEntryScrap extends RecipeEntryCraftingDynamic implements HasJsonAdapter {
     public Item itemToScrap;
     public Item scrapYield;
     public ItemStack scrapYieldStack;
+    public int maxYield;
+
+    public RecipeEntryScrap() {
 
+    }
 
-    public RecipeEntryScrap(Item itemToScrap, Item scrapYield)
+    public RecipeEntryScrap(Item itemToScrap, Item scrapYield, int maxYield)
     {
         this.itemToScrap = itemToScrap;
         this.scrapYield = scrapYield;
+        this.maxYield = maxYield;
         scrapYieldStack = new ItemStack(scrapYield);
     }
 
     @Override
-    public boolean matches(CraftingContainer inventorycrafting)
+    public boolean matches(CraftingContainer craftingContainer)
     {
         int itemToScrapCount = 0;
         for (int x = 0; x < 3; x++)
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == itemToScrap.id)
                 {
@@ -44,11 +59,87 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
 
     @Override
     public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        ItemStack output = scrapYield.getDefaultStack();
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                return true;
+            } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                return true;
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(getOutput());
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {new RecipeSymbol(itemToScrap.getDefaultStack())};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
         return false;
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
     {
         float itemToScrapDamage = 0;
         float itemMaxDamage = 0;
@@ -58,7 +149,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
         {
             for (int y = 0; y < 3; y++)
             {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 if (stack.itemID == itemToScrap.id)
                 {
@@ -67,19 +158,19 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
                 }
             }
         }
-        float scrapYieldResult = ((itemMaxDamage - itemToScrapDamage) / itemMaxDamage) * 4;
+        float scrapYieldResult = (((itemMaxDamage - itemToScrapDamage) / itemMaxDamage) * (maxYield - 1)) + 1;
         if(scrapYieldResult >= 1)
             return new ItemStack(scrapYield, (int)scrapYieldResult);
         return null;
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
         ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++)
         {
             for(int y = 0; y < 3; y++) {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 ItemStack stack2;
                 if(stack.stackSize-1 == 0)
@@ -87,7 +178,7 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
                 else {
                     stack2 = new ItemStack(stack.getItem(), stack.stackSize - 1);
                 }
-                inventorycrafting.setSlotContentsAt(x, y, stack2);
+                craftingContainer.setSlotContentsAt(x, y, stack2);
             }
         }
         return returnStack;
@@ -97,4 +188,9 @@ public class RecipeEntryScrap extends RecipeEntryCraftingDynamic{
     public int getRecipeSize() {
         return 2;
     }
+
+    @Override
+    public RecipeJsonAdapter<?> getAdapter() {
+        return new RecipeEntryScrapJsonAdapter();
+    }
 }
